/*
 * scratch.c
 *
 *  Created on: Apr 18, 2018
 *      Author: fg3ypy
 */

#include "scratch.h"

#ifdef SCRATCH_ENABLED

#include "sharedBuffers.h"

static uint32_t *scratchPtr;
static uint32_t *scratchStart;
static uint32_t *scratchEnd;
static uint32_t scratchCount;

void scratchInitialise(void *base)
{
	scratchStart = (uint32_t *) base;
	scratchPtr   = scratchStart;
	scratchEnd   = scratchStart + (CODEC_SCRATCH_MEMORY_SIZE >> 2);
	scratchCount = 0;
}

void scratchLog(uint32_t value)
{
	*scratchPtr++ = (scratchCount << 24) | (value & 0x00FFFFFF);
	if (scratchPtr >= scratchEnd)
		scratchPtr = scratchStart;
	scratchCount = (scratchCount + 1) & 0xFF;
}

#endif

