# ----------------------------------------------------------------------------
# Copyright (c) 2017 Semiconductor Components Industries, LLC (d/b/a
# ON Semiconductor), All Rights Reserved
#
# This code is the property of ON Semiconductor and may not be redistributed
# in any form without prior written permission from ON Semiconductor.
# The terms of use and warranty for this code are covered by contractual
# agreements between ON Semiconductor and the licensee.
#
# This is Reusable Code.
#
# -----------------------------------------------------------------------------
#

from baseFileStreamWrapper import baseFileStreamWrapper

def toBytes(line):
    ''' Helper method to decode four hex characters into a word '''
    return bytearray(line[2:6].decode("hex"))

class hexWordStream(baseFileStreamWrapper):
    ''' specific file wrapper for a word stream encoded file '''

    def __init__(self, wrappedFile):
        ''' Constructor takes the file to be wrapped '''
        super(hexWordStream, self).__init__(wrappedFile)
        self._loadFile()
    
    def _loadFile(self):
        ''' load the contents of the file into memory '''
        self.bytes = bytearray()
        for line in self.wrappedFile:
            self.bytes.extend(toBytes(line))
        self.fp = 0
        
    def read(self, numBytes):
        ''' we only provide a read method on this file type '''
        result = self.bytes[self.fp:self.fp + numBytes]
        print len(result)
        self.seek(numBytes, 1)
        return result

